'--------------------------------------------------------------
'Ansteuereungsbeispiele fr SAA1064 / I2C-7Seg4
' zur C-Control Micro
'CCTools 2004 http://cctools.hs-control.de (16.09.2005)
'--------------------------------------------------------------
' Zeitausgabe ber I2C-7Seg4
'--------------------------------------------------------------

define SCL PORT[5] ' Pull-Up mit 4,7k bis 10k notwendig
define SDA PORT[6] ' Pull-Up mit 4,7k bis 10k notwendig


define i byte[1] 'temporres Byte
define data byte[2] 'Byte zur Datenbergabe zu/von IC-Bus-Routinen
define temp byte[3] 'temporres Byte

Define Dot   &b10000000
Define Minus &b01000000

define SAA1064 112 'Adresse des SAA1064. Alternativ kann auch eine Variable benutzt werden.

baud 9600

gosub i2c_stop ' "Initialisierung" des IC-Busses

hour=12
minute=30

gosub initSAA

#loop
 data = SAA1064
 gosub i2c_start
 data = 1 'Register 1 = 1. 7-Segment-LED
 gosub i2c_write

 looktab SAAdigit,hour/10, data
 gosub i2c_write

 looktab SAAdigit,(hour mod 10), data 'Dezimal-Punkt zwischen zweiter und dritter Ziffer
 data = data or Dot
 gosub i2c_write

 looktab SAAdigit,minute/10, data
 gosub i2c_write
 
 looktab SAAdigit,minute mod 10, data
 gosub i2c_write
 gosub i2c_stop

 pause 75
 data = SAA1064
 gosub i2c_start
 data = 1 'Register 1 = 1. 7-Segment-LED
 gosub i2c_write

 data = 0
 gosub i2c_write

 data = Dot
 gosub i2c_write

 looktab SAAdigit,second/10, data
 gosub i2c_write

 looktab SAAdigit,second mod 10, data
 gosub i2c_write
 gosub i2c_stop

 pause 75
goto loop

#initSAA
 data = SAA1064
 gosub i2c_start
 data = 0
 gosub i2c_write
 data = &b00110111 ' 9mA, 4 7Segment-LEDs
 gosub i2c_write 'Statusregister schreiben
 for temp = 1 to 4 'alle LEDs aus
  data = 0
  gosub i2c_write
 next
 gosub i2c_stop
return


table SAAdigit 'Bitmuster fr Segmente
&b0111111 &b0000110 &b1011011 &b1001111 '0,1,2,3
&b1100110 &b1101101 &b1111101 &b0000111 '4,5,6,7
&b1111111 &b1101111 &b1110111 &b1111100 '8,9,A,B
&b0111001 &b1011110 &b1111001 &b1110001 'C,D,E,F
tabend

'---------------------------------------
'IC-Bus-Routinen
'---------------------------------------
'---------------------------------------
#i2c_stop
'---------------------------------------
 SDA = 0
 DEACT SCL
 DEACT SDA
return

'---------------------------------------
#i2c_start 'returns Ack in i
'---------------------------------------
 SDA = 1
 SCL = 1
 SDA = 0
 SCL = 0
'---------------------------------------
#i2c_write 'returns Ack in i
'---------------------------------------
 SDA = data AND &h80
 TOG SCL
 TOG SCL
 for i=1 to 7
  SDA = data AND (&h80 SHR i)
  TOG SCL
  TOG SCL
 next
 DEACT SDA
 TOG SCL
 i = NOT SDA
 TOG SCL
return

'---------------------------------------
#i2c_read 'returns Databyte in data
'---------------------------------------
 gosub i2c_sub_read
 SDA = 0
 TOG SCL
 TOG SCL
return

'---------------------------------------
#i2c_readlast 'returns Databyte in data
'---------------------------------------
 gosub i2c_sub_read
 TOG SCL
 TOG SCL
return

#i2c_sub_read
 DEACT SDA
 data = 0
 for i=0 to 7
  TOG SCL
  data = (data shl 1) or (SDA and 1)
  TOG SCL
 next
return

